Package com.tick42.glue.office.spreadsheets

# Interface Sheet<T>

Type Parameters:
  `T` - type of the data

All Superinterfaces:
  `AsynchronousCloseable`, `AutoCloseable`

    public interface Sheet<T>
    extends AsynchronousCloseable

Sheet.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `CompletionStage<?>` | `changeColumns​(BiConsumer<ColumnsBuilder<?>,​RowsBuilder<T,​?>> config)` | Change the columns (and optionally the rows) in the sheet.
  `default CompletionStage<?>` | `changeColumns​(Consumer<ColumnsBuilder<?>> config)` | Change the columns in the sheet, keeping the existing data.
  `CompletionStage<?>` | `changeData​(Consumer<RowsBuilder<T,​?>> data)` | Change the rows in this sheet.
  `AsynchronousCloseable` | `onChange​(SheetChangeHandler<T> handler)` | Registers a change handler to be invoked when the sheet is changed in Excel.
  `CompletionStage<?>` | `open()` | Opens this sheet.

  ### Methods inherited from interface com.tick42.glue.core.AsynchronousCloseable

  `close, closeAsync, onClose`

- ## Method Details

  - ### open

    CompletionStage<?> open()
    Opens this sheet.
    Returns:
      stage that will complete when sheet is opened, never `null`

  - ### changeData

    CompletionStage<?> changeData​(Consumer<RowsBuilder<T,​?>> data)
    Change the rows in this sheet.
    Parameters:
      `data` - function that builds the rows
    Returns:
      stage that will complete when data is changed, never `null`

  - ### changeColumns

    default CompletionStage<?> changeColumns​(Consumer<ColumnsBuilder<?>> config)
    Change the columns in the sheet, keeping the existing data.
    Parameters:
      `config` - function that builds the columns
    Returns:
      stage that will complete when columns are changed, never `null`

  - ### changeColumns

    CompletionStage<?> changeColumns​(BiConsumer<ColumnsBuilder<?>,​RowsBuilder<T,​?>> config)
    Change the columns (and optionally the rows) in the sheet.
    Parameters:
      `config` - function that builds the columns (and rows)
    Returns:
      stage that will complete when columns (and rows) are changed, never `null`

  - ### onChange

    AsynchronousCloseable onChange​(SheetChangeHandler<T> handler)
    Registers a change handler to be invoked when the sheet is changed in Excel.

    `SheetChangeHandler.onChange(SheetChange)` may return any validation errors to be shown to the user.

    Parameters:
      `handler` - function that will receive the change and return validation errors
    Returns:
      reference that can be used to unregister the handler, never `null`